package xyz.twovb.sgm.commands.impl;

/*
 * Created by 2vb - 4/6/2024
 */

import dev.rollczi.litecommands.annotations.argument.Arg;
import dev.rollczi.litecommands.annotations.command.Command;
import dev.rollczi.litecommands.annotations.context.Context;
import dev.rollczi.litecommands.annotations.execute.Execute;
import dev.rollczi.litecommands.annotations.permission.Permission;
import org.bukkit.Bukkit;
import org.bukkit.NamespacedKey;
import org.bukkit.World;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import xyz.twovb.sgm.SGM;
import xyz.twovb.sgm.levels.LevelManager;
import xyz.twovb.toolbox.api.CustomPlayer;
import xyz.twovb.toolbox.managers.PlaceholderManager;
import xyz.twovb.toolbox.utils.ChatUtils;

import java.util.Optional;
import java.util.UUID;

@Command(name = "level")
@Permission("sgm.levels")
public class LevelCommand {

    @Execute(name = "create")
    @Permission("sgm.levels.create")
    void create(@Context CommandSender sender, @Arg("game") String game, @Arg("name") Optional<String> LevelName) {
        String name = LevelName.orElse(UUID.randomUUID().toString());
        LevelManager.CreationResult result = LevelManager.createLevel(name, game);
        switch (result) {
            case SUCCESS:
                sender.sendMessage(ChatUtils.translate(PlaceholderManager.setPlaceholders(SGM.getInstance().getMessages().getString("sgm.level.new"), sender).replace("%level%", name)));
                break;
            case WORLD_EXISTS:
                sender.sendMessage(ChatUtils.translate(PlaceholderManager.setPlaceholders(SGM.getInstance().getMessages().getString("sgm.level.exists"), sender).replace("%level%", name)));
                break;
            case INVALID_ARGS:
                sender.sendMessage(ChatUtils.translate(PlaceholderManager.setPlaceholders(SGM.getInstance().getMessages().getString("sgm.game.not-found"), sender)));
                break;
            case UNKNOWN:
            default:
                sender.sendMessage(ChatUtils.translate(PlaceholderManager.setPlaceholders(SGM.getInstance().getMessages().getString("commands.unknown-error"), sender).replace("%error%", "(UNKNOWN)")));
                break;
        }
    }

    @Execute(name = "edit")
    @Permission("sgm.levels.edit")
    void edit(@Context Player player, @Arg("name") String name) {
        CustomPlayer cPlayer = new CustomPlayer(player);
        World world = LevelManager.getLevel(name);
        player.teleport(world.getSpawnLocation());
        cPlayer.sendMessage("<red>tele&aport");
    }

}
